#!/bin/bash
#
#   Hitachi Raid Adapter Driver Installer for RHEL6
#
#   $Header: /home/cvs_linux_driver/trunk/Linux_Driver/tools/install/hrainst.el6.sh,v 1.3 2008/12/05 07:58:15 inoue Exp $
#   $Log: hrainst.el6.sh,v $
#   Revision 1.3  2008/12/05 07:58:15  inoue
#   comment line delete # ignore
#
#   Revision 1.2  2008/11/07 07:21:34  raid
#   RHEL5.3 DUM support # ignore
#
#   Revision 1.1.1.1  2008/11/05 11:42:39  raid
#   start
#
#
if [ "$1" != "install" -a "$1" != "uninstall" ]; then
        echo "Usage : hrainst.el6.sh install/uninstall [kvariant]"
        echo "example(install  ) : hrainst.el6.sh install"
        echo "       (uninstall) : hrainst.el6.sh uninstall"
        exit 1
fi
DRVDIR="drivers"
DRVMODU="hradrv"
HOSTTYPE=$(uname -m)
TOOLSDIR="/opt/hitachi/drivers/hra"
INSTLOG="/tmp/hradrv_install.log"
	KERN60="2.6.32-71.el6"
	KERNVER=`uname -r`
KERNEL2=`uname -r | sed -e 's,[^\.]*\.,,' -e 's,\..*,,'`
KERNEL3=`uname -r | sed -e 's,[^\.]*\.,,' -e 's,[^\.]*\.,,' -e 's,\-.*,,'`
if [ "$HOSTTYPE" = "ia64" ]; then
	BOOTDIR="boot/efi/efi/redhat"
else
	BOOTDIR="boot"
fi
echo "      Boot directory      : $BOOTDIR" > $INSTLOG
if [ $KERNEL2 = "4" ] || [ $KERNEL3 = "9" ]; then
	echo " ---- Kernel version is 2.4 or 2.6.9 (/etc/$MODCONF)"  >> $INSTLOG
	exit 1
fi
MODCONF="hradrv.conf"
if [ ! -f "/etc/modprobe.d/$MODCONF" ]; then
	echo " ---- No configuration file was found (/etc/modprobe.d/$MODCONF)"  >> $INSTLOG
#	exit 1
fi
DRVNAME="hradrv.ko"
echo "      Configulation file  : $MODCONF"    >> $INSTLOG
echo "      Kernel version      : $KERNVER"    >> $INSTLOG
echo "      Host Type           : `uname -m`"  >> $INSTLOG
if [ "$1" = "install" ]; then
	echo " ---- Install  @Hitachi Raid Adapter Driver - `date`" >> $INSTLOG
	find /lib/modules/$KERNVER/updates -name $DRVNAME -exec mv {} {}.backup \;
	find /lib/modules/$KERNVER/kernel  -name $DRVNAME -exec mv {} {}.backup \;
#	echo "      Modify /etc/$MODCONF; old file is /etc/$MODCONF.backup"   >> $INSTLOG
#	cp /etc/$MODCONF /etc/$MODCONF.backup
#	sed '/^#/s/scsi_hostadapter/hoge_hogehoge/g' /etc/modprobe.d/$MODCONF > /etc/modprobe.d/$MODCONF.temp
#	mv /etc/modprobe.d/$MODCONF.temp /etc/modprobe.d/$MODCONF
#	if [ `grep -c "scsi_hostadapter[0-9]*[[:space:]]\+hradrv" /etc/modprobe.d/$MODCONF` -eq 0 ]; then
#		COUNT=`grep -c "scsi_hostadapter" /etc/modprobe.d/$MODCONF`
#		if [ $COUNT -eq 0 ]; then
#			echo "alias scsi_hostadapter0 hradrv" >> /etc/modprobe.d/$MODCONF
#		elif [ $COUNT -eq 1 ]; then
#			#########################################################################################################
#			#
#			# the following cases:
#			#  1. alias scsi_hostadapter xxxxxx
#			#
#			#  2. alias scsi_hostadapterN xxxxxx
#			#
#			# after modified:
#			#  1. alias scsi_hostadapter xxxxxx
#			#     alias scsi_hostadapter1 hradrv
#			#
#			#  2. alias scsi_hostadapterN xxxxxx
#			#     alias scsi_hostadapterN+1 hradrv
#			#
#			#########################################################################################################
#			if [ `grep -c "scsi_hostadapter[ ]" /etc/modprobe.d/$MODCONF` -eq 0 ]; then
#				COUNT=`sed -n s/alias[[:space:]]*scsi_hostadapter//p /etc/modprobe.d/$MODCONF|awk 'BIGIN{n=0};$1>n{n=$1};END{print n}'`
#				LN=`sed -n /scsi_hostadapter0*$COUNT/{=} /etc/modprobe.d/$MODCONF`
#				COUNT=`expr $COUNT + 1`
#				sed "$LN"a"alias scsi_hostadapter$COUNT hradrv" /etc/modprobe.d/$MODCONF > /etc/modprobe.d/$MODCONF.temp
#				mv /etc/modprobe.d/$MODCONF.temp /etc/mpdprobe.d/$MODCONF
#			else
#				LN=`sed -n /scsi_hostadapter/{=} /etc/modprobe.d/$MODCONF`
#				sed "$LN"a"alias scsi_hostadapter$COUNT hradrv" /etc/modprobe.d/$MODCONF > /etc/modprobe.d/$MODCONF.temp
#				mv /etc/modprobe.d/$MODCONF.temp /etc/modprobe.d/$MODCONF
#			fi
#		else
#			#########################################################################################################
#			#
#			# the following cases:
#			#  1. alias scsi_hostadapter xxxxxx
#			#     alias scsi_hostadapterN xxxxxx
#			#
#			#  2. alias scsi_hostadapterM xxxxxx
#			#     alias scsi_hostadapterN xxxxxx
#			#
#			# after modified:
#			#  1. alias scsi_hostadapter xxxxxx
#			#     alias scsi_hostadapterN+1 hradrv
#			#
#			#  2. alias scsi_hostadapterM xxxxxx
#			#     alias scsi_hostadapterN+1 hradrv
#			#
#			#########################################################################################################
#			cp /etc/modprobe.d/$MODCONF /etc/modprobe.d/$MODCONF.temp
#			ADAP=`grep -c "scsi_hostadapter[ ]" /etc/modprobe.d/$MODCONF`
#			ADAP0=`grep -c "scsi_hostadapter0*0[ ]" /etc/modprobe.d/$MODCONF`
#			if [ $ADAP -gt 2 ] || [ $ADAP0 -gt 2 ]; then
#				echo " @ERR double assigned scsi_hostadapter number" >> $INSTLOG
#				sed '/^#/s/hoge_hogehoge/scsi_hostadapter/g' /etc/modprobe.d/$MODCONF > /etc/modprobe.d/$MODCONF.temp
#				mv /etc/modprobe.d/$MODCONF.temp /etc/modprobe.d/$MODCONF
#				exit 1
#			fi
#			if [ $ADAP -eq 1 ]; then
#				# intentional character
#				sed s/"scsi_hostadapter "/"scsi_xxxxxxxxxxx "/ /etc/modprobe.d/$MODCONF > /etc/modprobe.d/$MODCONF.temp
#			fi
#			COUNT=`sed -n s/alias[[:space:]]*scsi_hostadapter//p /etc/modprobe.d/$MODCONF.temp|awk 'BIGIN{n=0};$1>n{n=$1};END{print n}'`
#			LN=`sed -n /scsi_hostadapter0*$COUNT/{=} /etc/modprobe.d/$MODCONF.temp`
#			COUNT=`expr $COUNT + 1`
#			sed "$LN"a"alias scsi_hostadapter$COUNT hradrv" /etc/modprobe.d/$MODCONF > /etc/modprobe.d/$MODCONF.temp
#			mv /etc/modprobe.d/$MODCONF.temp /etc/modprobe.d/$MODCONF
#		fi
#	fi
#	sed '/^#/s/hoge_hogehoge/scsi_hostadapter/g' /etc/modprobe.d/$MODCONF > /etc/modprobe.d/$MODCONF.temp
#	mv /etc/modprobe.d/$MODCONF.temp /etc/modprobe.d/$MODCONF
	echo " ---- Install Success "   >> $INSTLOG
else
	echo " ---- Uninstall  @Hitachi Raid Adapter Driver - `date`"   > $INSTLOG
#	echo "      Modify /etc/modprobe.d/$MODCONF"   >> $INSTLOG
#	sed '/^#/s/scsi_hostadapter/hoge_hogehoge/g' /etc/modprobe.d/$MODCONF > /etc/modprobe.d/$MODCONF.temp
#	sed '/alias scsi_hostadapter.* hradrv/d' /etc/modprobe.d/$MODCONF.temp > /etc/modprobe.d/$MODCONF
#	rm /etc/modprobe.d/$MODCONF.temp
#	cp /etc/modprobe.d/$MODCONF /etc/modprobe.d/$MODCONF.temp
#	sed '/^#/s/hoge_hogehoge/scsi_hostadapter/g' /etc/modprobe.d/$MODCONF > /etc/modprobe.d/$MODCONF.temp
#	mv /etc/modprobe.d/$MODCONF.temp /etc/modprobe.d/$MODCONF
    echo " ---- Uninstall Success "   >> $INSTLOG
fi
